src/Sonata/Bundle/DemoBundle/Form/Type/NewsletterType.php
<?php

/*
 * This file is part of the Sonata project.
 *
 * (c) Thomas Rabaix <thomas.rabaix@sonata-project.org>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

namespace Sonata\Bundle\DemoBundle\Form\Type;

use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\FormBuilderInterface;

/**
 * Class NewsletterType
 *
 * This is the newsletter subscription/unsubscription form type
 *
 * @author Vincent Composieux <vincent.composieux@gmail.com>
 */
class NewsletterType extends AbstractType
{
    /**
     * {@inheritdoc}
     */
    public function buildForm(FormBuilderInterface $formBuilder, array $options)
    {
        $formBuilder
            ->add('email', 'email', array(
                'attr' => array(
                    'placeholder' => "Email"
                )
            ))
        ;
    }

    /**
     * {@inheritdoc}
     */
    public function getName()
    {
        return 'sonata_demo_form_type_newsletter';
    }
}

src/Sonata/Bundle/DemoBundle/Controller/DemoController.php
<?php

/*
 * This file is part of the Sonata project.
 *
 * (c) Thomas Rabaix <thomas.rabaix@sonata-project.org>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

namespace Sonata\Bundle\DemoBundle\Controller;

use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Sonata\Bundle\DemoBundle\Entity\MediaPreview;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;
use Sonata\Bundle\DemoBundle\Form\Type\CarType;

class DemoController extends Controller
{
    /**
     * @param \Symfony\Component\HttpFoundation\Request $request
     *
     * @return \Symfony\Component\HttpFoundation\Response
     */
    public function carAction(Request $request)
    {
        $form = $this->createForm(new CarType());

        if ($request->getMethod() == 'POST') {
            $form->bind($request);
        }

        ob_start();
        var_dump($form->getData());
        $dump = ob_get_contents();
        ob_clean();

        return $this->render('SonataDemoBundle:Demo:car.html.twig', array(
            'form' => $form->createView(),
            'dump' => $dump
        ));
    }

    /**
     * @param \Symfony\Component\HttpFoundation\Request $request
     *
     * @return \Symfony\Component\HttpFoundation\Response
     */
    public function carRescueEngineAction(Request $request)
    {
        $car = new \Sonata\Bundle\DemoBundle\Entity\Car();
        $car->setName('Poney Car');
        $car->setCreatedAt(new \DateTime);

        $rescueEngines = array(
            1 => new \Sonata\Bundle\DemoBundle\Entity\Engine('Rescue 1', 100),
            2 => new \Sonata\Bundle\DemoBundle\Entity\Engine('Rescue 2', 125),
            3 => new \Sonata\Bundle\DemoBundle\Entity\Engine('Rescue 3', 150),
        );

        $form = $this->createForm('sonata_demo_form_type_car', $car, array(
            'rescue_engines' => $rescueEngines
        ));

        if ($request->getMethod() == 'POST') {
            $form->bind($request);
        }

        ob_start();
        var_dump($car);
        $dump = ob_get_contents();
        ob_clean();


        return $this->render('SonataDemoBundle:Demo:car.html.twig', array(
            'form' => $form->createView(),
            'dump' => $dump
        ));
    }

    /**
     * @param \Symfony\Component\HttpFoundation\Request $request
     *
     * @return \Symfony\Component\HttpFoundation\Response
     */
    public function mediaAction(Request $request)
    {
        // preset a default value
        $media = $this->get('sonata.media.manager.media')->create();
        $media->setBinaryContent('http://www.youtube.com/watch?v=oHg5SJYRHA0');

        // create the target object
        $mediaPreview = new MediaPreview();
        $mediaPreview->setMedia($media);

        // create the form
        $builder = $this->createFormBuilder($mediaPreview);
        $builder->add('media', 'sonata_media_type', array(
             'provider' => 'sonata.media.provider.youtube',
             'context'  => 'default'
        ));

        $form = $builder->getForm();

        // bind and transform the media's binary content into real content
        if ($request->getMethod() == 'POST') {
            $form->bind($request);

            $this->getSeoPage()
                ->setTitle($media->getName())
                ->addMeta('property', 'og:description', $media->getDescription())
                ->addMeta('property', 'og:type', 'video')
            ;
        }

        return $this->render('SonataDemoBundle:Demo:media.html.twig', array(
            'form' => $form->createView(),
            'media' => $mediaPreview->getMedia()
        ));
    }

    /**
     * Newsletter subscription action
     *
     * @param \Symfony\Component\HttpFoundation\Request $request
     *
     * @return \Symfony\Component\HttpFoundation\Response
     */
    public function newsletterAction(Request $request)
    {
        $form = $this->createForm('sonata_demo_form_type_newsletter');
        $form->handleRequest($request);

        $message = 'sonata.demo.block.newsletter.message';

        return $this->render('SonataDemoBundle:Block:newsletter_confirmation.html.twig', array(
            'message' => $form->isValid() ? $message : null
        ));
    }

    /**
     * @return \Sonata\SeoBundle\Seo\SeoPageInterface
     */
    private function getSeoPage()
    {
        return $this->get('sonata.seo.page');
    }
}

src/Sonata/Bundle/DemoBundle/Resources/views/Demo/car.html.twig
{% extends '::empty.html.twig' %}

{% form_theme form _self %}


{% block content %}
    <h2>Car Type</h2>
    <h3>Object</h3>
    <div>
        {{ dump|raw }}
    </div>

    <h3>Form Version</h3>

    <div>
        <form method="POST">
            {{ form_rest(form) }}
            <input type="submit" />
        </form>
    </div>
{% endblock %}


{% block _sonata_demo_form_type_car_rescueEngine_label %}
    {{ block('form_label') }}
    sfsdfsd
{% endblock %}

src/Sonata/Bundle/DemoBundle/Resources/views/Demo/media.html.twig
<h2>Form Media Type & SEO</h2>

<div>

    <p>
        The <code>form_media_type</code> allows to add a Media to an entity. The Media information will be stored in a dedicated media table. <br />

        <br />
        <strong>Example</strong> :
        Please enter a youtube url and press the "Preview Video" button. <br />

    </p>
    <form method="POST">
        {{ form_widget(form.media.binaryContent, {'attr': {'class': 'span8'}}) }}

        {{ form_rest(form) }}

        <input type="submit" class="btn" value="Preview Video"/>
    </form>
</div>

{% if media and media.providerReference %}
    <h2>Preview : {{ media.name }}</h2>

    {% media media, 'reference' %}

    <p>
        The <code>media</code> helper is used to render the video.
    </p>
{% endif %}

<h2>One more thing</h2>
<p>
    This page also uses the <code>SonataSeoBundle</code> to inject specific headers information. This is done by reading
    the Media information

    <script src="https://gist.github.com/1900366.js?file=gistfile1.aw"></script>
</p>

<h2>Usage</h2>

<h3>Controller</h3>

<script src="https://gist.github.com/1896425.js?file=gistfile1.aw"></script>

<h3>Template</h3>

<script src="https://gist.github.com/1896431.js?file=gistfile1.twig"></script>